/**
 * Implementieren Sie folgende statische Methoden, wobei die als
 * Parameter übergebenen Arrays nicht verändert werden dürfen.
 * <p/>
 * createHalveArray hat ein Array (wie von createArray in Aufgabe 3 zurückgegeben) als Parameter und gibt ein neues Array der selben Länge zurück, wobei die Elemente jeweils den
 * halben Wert des entsprechenden Elements des übergebenen Arrays haben; das übergebenen Array darf dabei nicht verändert werden. 30%
 * <p/>
 * columnLength hat zwei Parameter: ein zweidimensionales array a und eine ganze Zahl j; columnLength gibt den ersten Index i zurück, bei dem ein Zugriff a[i][j] nicht mehr erlaubt ist. 30%
 * <p/>
 * Beispiel: Array a enthält:
 * 1 2 3 4
 * 5 6 7
 * 8 9
 * 0 1 2 3
 * Dann gibt columnLength(a,0) 4 zurück, columnLength(a,1) auch 4, columnLength(a,2) 2, und columnLength(a,3) 1.
 * <p/>
 * Hinweis: Ob ein Zugriff auf ein Element i eines Arrays x erlaubt ist, können Sie mit x.length>i feststellen.
 * <p/>
 * createColumn hat zwei Parameter: ein zweidimensionales Array a und eine ganze Zahl j; createColumn gibt ein eindimensionales Array b (mit dem selben Elementtyp wie a) zurück,
 * wobei die Werte b[i] mit den Werten a[i][j] initialisiert werden; b ist so groß wie möglich, ohne dass bei der Initialisierung ein Fehler auftritt. 20%
 * <p/>
 * Beispiel: Beim oben genannten Array gibt
 * createColumn(a,0) ein Array mit den Werten 1 5 8 0 zurück;
 * createColumn(a,1) ein Array mit den Werten 2 6 9 1 zurück;
 * createColumn(a,2) ein Array mit den Werten 3 7 zurück;
 * createColumn(a,3) ein Array mit den Werten 4 zurück.
 * <p/>
 * createTransposed hat als Parameter ein zweidimensionales Array a, bei dem kein Unterarray a[i] länger ist als a[i-1]; a[0] ist beliebig lang. createTransposed gibt
 * ein neues zweidimensionales Array b zurück, wobei die Zeilen von b so lange sind wie die Spalte von a und auch die gleichen Werte enthalten (also b[i][j]==a[j][i]). 20%
 * <p/>
 * Beispiel: Array a enthält
 * 1 2 3 4
 * 5 6 7
 * 8 9 0
 * Dann gibt createTransposed(a) folgendes Array zurück:
 * 1 5 8
 * 2 6 9
 * 3 7 0
 * 4
 * <p/>
 * Hinweis: Sie können in createTransposed die Methode createColumn aufrufen.
 * <p/>
 * Optional (zuerst den Pflichtteil abgeben):
 * <p/>
 * innerProduct hat als Parameter zwei gleich lange eindimensionales Arrays a und b und gibt als Resultat das innere Produkt von a und bei zurück, also die Summe a[i]*b[i] für alle i.
 * <p/>
 * matrixProduct hat als Parameter zwei rechteckige zweidimensionale Arrays a und b, wobei a soviele Zeilen hat wie b Spalten und umgekehrt. Es gibt ein zweidimensionales Array c zurück, wobei
 * jedes Element c[i][j] das innere Produkt der Zeile a[i] mit der Spalte createColumn(b,j) ist.
 */
public class Adhoc5 {

}

/* Lösung(vowi)

    public class AdHoc {

        // debugging on/off - true/false
        static boolean debug = true;

        private static double[] halveArray(double arr[]) {
            double[] result = new double[arr.length];


            for (int i = 0; i < arr.length; i++)
                result[i] = (int) (arr[i] / 2);

            if (debug) {
                System.out.print("\n[debug] halveArray: ");
                for (double i : arr) System.out.print(i + ", ");
                System.out.println();
            }
            return result;
        }

        private static int columnLength(int[][] a, int j) {
            int result = 0;

            for (int i = 0; i < a.length; i++) {
                if (a[i].length >= j + 1) {
                    result++;
                } else {
                    break;
                }
            }
            return result;
        }

        private static int[] createColumn(int[][] a, int j) {
            int x = columnLength(a, j);
            int[] result = new int[x];

            for (int i = 0; i < x; i++) {
                result[i] = a[i][j];
            }

            if (debug) {
                System.out.print("[debug] Array: ");
                for (int i : result) System.out.print(i + ", ");
                System.out.println();
            }
            return result;
        }

        private static int[][] createTransposed(int[][] a) {
            int[][] result = new int[a[0].length][];

            for (int i = 0; i <= a.length; i++) {
                result[i] = createColumn(a, i);
            }

            return result;
        }

        public static void main(String[] args) {
            int[][] a = {{1, 2, 3, 4},
                    {5, 6, 7},
                    {8, 9},
                    {0, 1, 2, 3}};
            int[][] b = {{1, 2, 3, 4},
                    {5, 6, 7},
                    {8, 9, 0}
            };
            System.out.println("Test columnLength:");
            System.out.println(columnLength(a, 0) + " = 4");
            System.out.println(columnLength(a, 1) + " = 4");
            System.out.println(columnLength(a, 2) + " = 2");
            System.out.println(columnLength(a, 3) + " = 1");

            System.out.println("\nTest createColumn:");
            int test1[] = createColumn(a, 0);
            int test2[] = createColumn(a, 1);
            int test3[] = createColumn(a, 2);
            int test4[] = createColumn(a, 3);

            System.out.println("\nTest createTransposed: ");
            int test5[][] = createTransposed(b);
        }
    }


 */
