import java.util.*;
/**
 * Die Umgekehrte Polnische Notation (kurs UPN) ist eine Schreibweise für Operationen bei der zuerst die Operanden und erst danach der Operator
 * angeschrieben wird. In UPN-Schreibweise von rechts nach links bedeutet also beispielsweise der Ausdruck
 *
 *      + 13 5
 *
 *  nichts anderes als
 *
 *      5+ 13
 *
 * was als Resultat 18 ergibt. Erstellen Sie im vorliegenden Programm die statische Methode mit Kopf
 *
 * public static void dingleComputation(Deque<UPN_Rechner> quueue_local)
 *
 * sodass sie den Ausdruck [5+13+(-4)+(-2)]*13*(-5)+8
 *
 * in polnischer Notation von rechts nach links
 * +8*5-6*13+-2+-4+13  5
 *
 * Schritt für Schritt berechnen kann. Bei jedem Schritt werden die beiden Werte ganz rechts vom Ausdruck (hier 13 und 5) entnommen und
 * danach auch der Oparator (nur + oder *) daneben und auf sie angewandt (hier 13+5 =18). Das Ergebnis soll dann zum Ausdruck rechts
 * hinzugefügt werden. Hier entsteht also der neue Ausdruck
 *
 * +8*5-6*13+-2+-4  18
 *
 * Am Ende soll nur das Ergebnis -772 in der relevaten Deque zu finden sein. Die Methode singleComputation soll für jeden UPN-Ausdruck
 * in der Deque funktionieren, der sich auf diese Weise Schritt für Schritt auswerten lässt.
 */


public class AdHoc2 {
    public boolean is_value;  // Does this object actually contain a value or an operator ?
    public int value;         // Relevant  iff  is_value == true
    public String operator;   // Either "+" or "*" if  is_value == false

    public AdHoc2(boolean is_value_local, int value_local, String operator_local) {
        this.is_value = is_value_local;
        this.value = value_local;
        this.operator = operator_local;
    }

    public static Deque<AdHoc2> printQueue(Deque<AdHoc2> queue_local) {
        Deque<AdHoc2> result_queue = new LinkedList<AdHoc2>();

        int queue_local_size = queue_local.size();

        // for (int i = 0; i < queue_local.size(); i++) {
        for (int i = 0; i < queue_local_size; i++) {
            AdHoc2 upn_rechner = queue_local.poll();

            if (upn_rechner.is_value) {
                System.out.print(upn_rechner.value);
            }
            else {
                System.out.print(upn_rechner.operator);
            }

            if (i < queue_local_size -1) {
                System.out.print(", ");
            }

            result_queue.offerLast(upn_rechner);
        }

        System.out.println();

        return result_queue;
    }

    public static void singleComputation(Deque<AdHoc2> queue_local) {
        // 1) Take three objects UPN_Rechner from the end of the Deque - two operands followed by one operator.
        //    (You can use queue_local.pollLast() three times.)
        // 2) Distinguish between the operators "+" and "*".
        // 3) Compute the resulting value.
        // 4) Store the resulting value as a new object UPN_Rechner (where  is_value == true).
        //    Use the constructor of UPN_Rechner (with the keyword new).
        // 5) Put this new object at the end of the Deque instead of the three prior objects from step 1.
        //    (You can use queue_local.offerLast(***ADD VARIABLE***).)

        // ***IHRE IMPLEMENTIERUNG***
    }

    public static void main(String[] args) {
        Deque<AdHoc2> queue = new LinkedList<AdHoc2>();

        AdHoc2 e1 = new AdHoc2(true, 5, null);
        queue.offerFirst(e1);
        queue = printQueue(queue);
        // queue = printQueue(queue);
        // 5

        AdHoc2 e2 = new AdHoc2(true, 13, null);
        queue.offerFirst(e2);
        queue = printQueue(queue);
        // 13, 5

        AdHoc2 e3 = new AdHoc2(false, Integer.MIN_VALUE, "+");
        queue.offerFirst(e3);
        queue = printQueue(queue);
        // +, 13, 5

        AdHoc2 e4 = new AdHoc2(true, -4, null);
        queue.offerFirst(e4);
        queue = printQueue(queue);
        // -4, +, 13, 5

        AdHoc2 e5 = new AdHoc2(false, Integer.MIN_VALUE, "+");
        queue.offerFirst(e5);
        queue = printQueue(queue);
        // +, -4, +, 13, 5


        /*****************************************************
         ***              Rechenschritt !                  ***
         *****************************************************/
        singleComputation(queue);
        queue = printQueue(queue);
        // +, -4, 18


        AdHoc2 e6 = new AdHoc2(true, -2, null);
        queue.offerFirst(e6);
        queue = printQueue(queue);
        // -2, +, -4, 18

        AdHoc2 e7 = new AdHoc2(false, Integer.MIN_VALUE, "+");
        queue.offerFirst(e7);
        queue = printQueue(queue);
        // +, -2, +, -4, 18

        AdHoc2 e8 = new AdHoc2(true, 13, null);
        queue.offerFirst(e8);
        queue = printQueue(queue);
        // 13, +, -2, +, -4, 18

        AdHoc2 e9 = new AdHoc2(false, Integer.MIN_VALUE, "*");
        queue.offerFirst(e9);
        queue = printQueue(queue);
        // *, 13, +, -2, +, -4, 18

        AdHoc2 e10 = new AdHoc2(true, -5, null);
        queue.offerFirst(e10);
        queue = printQueue(queue);
        // -5, *, 13, +, -2, +, -4, 18

        AdHoc2 e11 = new AdHoc2(false, Integer.MIN_VALUE, "*");
        queue.offerFirst(e11);
        queue = printQueue(queue);
        // *, -5, *, 13, +, -2, +, -4, 18

        AdHoc2 e12 = new AdHoc2(true, 8, null);
        queue.offerFirst(e12);
        queue = printQueue(queue);
        // 8, *, -5, *, 13, +, -2, +, -4, 18

        AdHoc2 e13 = new AdHoc2(false, Integer.MIN_VALUE, "+");
        queue.offerFirst(e13);
        queue = printQueue(queue);
        // +, 8, *, -5, *, 13, +, -2, +, -4, 18


        /*****************************************************
         ***            Restliche Rechenschritte           ***
         *****************************************************/
        singleComputation(queue);
        queue = printQueue(queue);
        // +, 8, *, -5, *, 13, +, -2, 14

        singleComputation(queue);
        queue = printQueue(queue);
        // +, 8, *, -5, *, 13, 12

        singleComputation(queue);
        queue = printQueue(queue);
        // +, 8, *, -5, 156

        singleComputation(queue);
        queue = printQueue(queue);
        // +, 8, -780

        singleComputation(queue);
        queue = printQueue(queue);
        // -772
    }
}


